<template>
  <main ref="main">
    <header>
      <h1>Message Tagger</h1>
    </header>
    <section>
      <div v-if="$store.getters.loading" class="loader"></div>
      <span v-else>{{$store.getters.message}}</span>
    </section>
    <footer>
      <button class="down" :disabled="!$store.getters.done" @click="$store.dispatch('reject')"></button>
      <button class="up" :disabled="!$store.getters.done" @click="$store.dispatch('accept')"></button>
    </footer>
  </main>
</template>

<script>
export default {
  data: () => ({
    accept: ["KeyZ", "KeyA", "Enter"],
    reject: ["KeyX", "KeyR", "Backspace"],
    startTouch: {}
  }),
  async created() {
    await this.$store.dispatch("login");
    await this.$store.dispatch("load");
  },
  mounted() {
    window.addEventListener("keypress", ({ code }) => {
      if (!this.$store.getters.done) return;
      else if (this.reject.includes(code)) this.$store.dispatch("reject");
      else if (this.accept.includes(code)) this.$store.dispatch("accept");
    });
    this.$refs.main.addEventListener("touchmove", e => {
      e.preventDefault();
    });
    this.$refs.main.addEventListener("touchstart", e => {
      this.startTouch = e.changedTouches[0];
    });
    this.$refs.main.addEventListener("touchend", e => {
      const touch = e.changedTouches[0].pageX - this.startTouch.pageX;
      if (!this.$store.getters.done) return;
      else if (touch <= -100) this.$store.dispatch("reject");
      else if (touch >= 100) this.$store.dispatch("accept");
    });
  }
};
</script>

<style lang="scss">
* {
  box-sizing: border-box;
}

body {
  padding: 0;
  margin: 0;
  background: #f7f7f7;
}

main {
  position: fixed;
  height: 100vh;
  width: 100vw;
  display: grid;
  grid-template: minmax(4rem, auto) minmax(auto, 100vw) minmax(8rem, auto) / 100vw;

  header {
    padding-left: 2rem;
  }
  section {
    margin: 2rem;
    padding: 2rem;
    box-shadow: 10px 10px 20px #0008;
    border-radius: 0.2rem;
    text-align: center;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  footer {
    padding: 1rem;
    display: flex;
    justify-content: space-evenly;
    align-items: center;

    button {
      width: 8rem;
      height: 4rem;
      border: none;
      border-radius: 50px;
      font-size: 2rem;
      background-size: 50%;
      background-repeat: no-repeat;
      background-position: 50%;
      box-shadow: 2px 2px 20px gray;
    }
  }
}

$red: rgb(228, 99, 99);
$green: rgb(114, 212, 90);

.down {
  background-image: url("assets/close-outline.svg");
  background-color: $red;
  &:disabled {
    background-color: desaturate($red, 20%);
  }
}
.up {
  background-image: url("assets/checkmark-outline.svg");
  background-color: $green;
  &:disabled {
    background-color: desaturate($green, 20%);
  }
}

.loader {
  border: 16px solid #f3f3f3;
  border-radius: 50%;
  border-top: 16px solid #3498db;
  width: 120px;
  height: 120px;
  -webkit-animation: spin 2s linear infinite; /* Safari */
  animation: spin 2s linear infinite;
}

@keyframes spin {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
</style>
